package domaine;

import java.util.StringTokenizer;

import domaine.temps.Heure;
import domaine.temps.HeureV2;
import domaine.temps.MauvaisFormatDHeure;
import domaine.temps.MauvaiseValeurDesHeures;
import domaine.temps.MauvaiseValeurDesMinutes;

public class Alarme implements Comparable<Alarme>, Operable {
    private Heure quand;
    private String quoi;
    public void affecteA(String nom, int h, int m) throws MauvaiseValeurDesHeures, MauvaiseValeurDesMinutes {
        quand.affecteA(h, m);
        quoi = nom;
    }
    public void affecteA(String nom, String heure) throws MauvaisFormatDHeure, MauvaiseValeurDesHeures, MauvaiseValeurDesMinutes {
        quand.affecteA(heure);
        quoi = nom;
    }
    public void affecteA(String texte) throws MauvaisFormatDHeure, MauvaiseValeurDesHeures, MauvaiseValeurDesMinutes {
        StringTokenizer st = new StringTokenizer(texte, "|");
        quand.affecteA(st.nextToken());
        quoi = st.nextToken();
    }
    public Alarme() {
        quand = new HeureV2();
        quoi = "sans nom";
    }
    public Alarme(int h, int m) throws MauvaiseValeurDesHeures, MauvaiseValeurDesMinutes {
        quand = new HeureV2(h, m);
        quoi = "sans nom";
    }
    public Alarme(String nom, int h, int m) throws MauvaiseValeurDesHeures, MauvaiseValeurDesMinutes {
        quand = new HeureV2();
        affecteA(nom, h, m);
    }
    public Alarme(String nom, String heure) throws MauvaisFormatDHeure, MauvaiseValeurDesHeures, MauvaiseValeurDesMinutes {
    	quand = new HeureV2();
    	affecteA(nom, heure);
    }
    public Alarme(String texteAlarme) throws MauvaisFormatDHeure, MauvaiseValeurDesHeures, MauvaiseValeurDesMinutes {
        quand = new HeureV2();
        affecteA(texteAlarme);
    }
    public String nom() { return quoi; }
    public void nom(String nom) {
        quoi = nom;
    }
    public Heure heure() { return quand; }
    public int heures() {
        return quand.heures();
    }
    public int minutes() {
        return quand.minutes();
    }
    public String toString() {
        return quand.toString() + " - " + quoi;
    }
    public String texte() {
    	return quand.toString() + "|" + quoi;
    }
    public int compareTo(Alarme autre) {
        int comparaison = quand.compareTo(autre.quand);
        if (comparaison == 0) comparaison = quoi.compareTo(autre.quoi);
        return comparaison;
    }
    public void realise(Operation op) throws Exception {
        op.opereSur(this);
    }
}
