package domaine.fichiers;

import java.io.DataOutputStream;
import java.io.FileOutputStream;
import java.io.IOException;

import application.Alarmes;
import domaine.Alarme;
import domaine.ListeDAlarmes;
import domaine.Operation;
import domaine.temps.Heure;

public class EnregistrementBinaire implements Operation {
	private DataOutputStream fichier;
	public EnregistrementBinaire(String nomDeFichier) throws IOException {
		fichier = new DataOutputStream(new FileOutputStream(nomDeFichier));
		fichier.writeByte(Alarmes.FILE_VERSION);
	}
	public void opereSur(ListeDAlarmes l) throws Exception {
		fichier.writeInt(l.nombreDElements());
        for (Alarme a : l) a.realise(this);
        fichier.close();
	}
	public void opereSur(Alarme a) throws Exception {
		a.heure().realise(this);
	}
	public void opereSur(Heure h) throws Exception {
		fichier.writeByte(h.heures());
		fichier.writeByte(h.minutes());
	}
}
