package vue;

import domaine.Alarme;

import java.awt.Dimension;
import java.awt.Frame;
import java.io.File;
import java.awt.Font;
import java.awt.FlowLayout;

import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.Clip;
import javax.swing.JDialog;
import javax.swing.JLabel;

public class DialogueAlarme extends JDialog {
	private static DialogueAlarme dialogueAlarme;
	private JLabel description;
	private Clip son;
	public static DialogueAlarme getInstance() {
		if (dialogueAlarme == null) dialogueAlarme = new DialogueAlarme();
		return dialogueAlarme;
	}
    private DialogueAlarme() {
        super((Frame)null, "Alarme", false);
        Dimension dim = new Dimension(400,100);
        setDefaultCloseOperation(JDialog.HIDE_ON_CLOSE);
        setSize(400,150); setResizable(false);
        setLayout(new FlowLayout());
        description = new JLabel("Il est l'heure", JLabel.CENTER);
        description.setFont(new Font("Arial", Font.BOLD, 20));
        description.setPreferredSize(dim);
        add(description);
		try {
			File file = new File("alarm.wav");
			AudioInputStream audioIn = AudioSystem.getAudioInputStream(file);
			son = AudioSystem.getClip();
			son.open(audioIn);
		} catch(Exception e) { e.printStackTrace(); }
    }
    public void affiche(Alarme a) {
		son.setFramePosition(0);
		son.start();
    	description.setText("Il est " + a.heure() + " !");
    	setVisible(true);
    }
}
