package domaine;

import static org.junit.jupiter.api.Assertions.*;

import java.util.Iterator;

import org.junit.jupiter.api.Test;

import domaine.temps.MauvaisFormatDHeure;
import domaine.temps.MauvaiseValeurDesHeures;
import domaine.temps.MauvaiseValeurDesMinutes;

class TestListeDAlarmes {
    @Test
    public void test01Constructeur() {
        ListeDAlarmes lst;
        lst = new ListeDAlarmes();
        assertTrue(lst.estVide());
        assertEquals(0, lst.nombreDElements());
    }
    @Test
    public void test02Ajout() throws MauvaisFormatDHeure, MauvaiseValeurDesHeures, MauvaiseValeurDesMinutes {
        ListeDAlarmes lst;
        lst = new ListeDAlarmes();
        lst.ajoute(new Alarme(18, 0));
        lst.ajoute(new Alarme("12:00|douze heures"));
        lst.ajoute(new Alarme("déjeuner", "12:00"));
        lst.ajoute(new Alarme("10:30|dix heures trente"));
        lst.ajoute(new Alarme("16:15|seize heures quinze"));
        lst.ajoute(new Alarme("dix heures trente", 10, 30));
        assertEquals(6, lst.nombreDElements());
        Alarme a1;
		Alarme a2;
        Iterator<Alarme> it = lst.iterator();
        boolean enOrdreCroissant = true;
        a1 = it.next();
        while(it.hasNext()) {
            a2 = it.next();
            if (a1.compareTo(a2) > 0) enOrdreCroissant = false;
            a1 = a2;
        }
        assertTrue(enOrdreCroissant);
    }
}
